#include "stm32f10x.h"

void CLK_init(void );//ϵͳʱú
void GPIO_init(void );//GPIOڳʼ
void delay_ms(unsigned int tmp);//ʱ


int main(void )
{
	CLK_init();
	GPIO_init();
	while(1)
	{
		GPIOA->BSRR=0x00040000;//λPA2
		GPIOA->BSRR=0x00000008;//PA3
		delay_ms(1000);
		GPIOA->BSRR=0x00000004;//PA2
		GPIOB->BSRR=0x00040000;//λPB2
		delay_ms(1000);
		GPIOA->BSRR=0x00080000;//λPA3
		GPIOB->BSRR=0x00000004;//PB2
		delay_ms(1000);	
	}	
}

void CLK_init(void )
{
	RCC->AHBENR=0x0001;//ʹDMA1ʱ
	RCC->APB2ENR=0x000c;//ʹGPIOA GPIOB ʱ
	RCC->CSR=0x00000000;//ϵ縴λ־λ
	RCC->CFGR=0x001d040a;//PLL9Ƶ	HSEʱ
	RCC->CR&=0x00030d02;//
	RCC->CIR=0x00000000;//жϱ־λ	
}

void GPIO_init(void )
{
	unsigned int Request_time;

	GPIOA->CRL=0x44443344;//PA2Ϊ
	GPIOA->CRH=0x44444444;//
	do
	{
		do
		{
			GPIOA->LCKR=0x0000000c;//PA2״̬ ´θλǰִ״̬
			GPIOA->LCKR=GPIOA->LCKR|0x00010000;//LCKK д1
			GPIOA->LCKR=GPIOA->LCKR&0xfffeffff;//LCKK д0
			GPIOA->LCKR=GPIOA->LCKR|0x00010000;//LCKK д1
			Request_time++;
			if(Request_time>100)
			{
				break;
			}
		}while(!(GPIOA->LCKR&0x00010000));//ȡΪ0 

	}while(GPIOA->LCKR&0x00010000);//ȡΪ1

	GPIOB->CRL=0x44444344;//PB2Ϊ
	GPIOB->CRH=0x44444444;//
	do
	{
		do
		{
			GPIOB->LCKR=0x00000004;//PA2״̬ ´θλǰִ״̬
			GPIOB->LCKR=GPIOB->LCKR|0x00010000;//LCKK д1
			GPIOB->LCKR=GPIOB->LCKR&0xfffeffff;//LCKK д0
			GPIOB->LCKR=GPIOB->LCKR|0x00010000;//LCKK д1
			Request_time++;
			if(Request_time>100)
			{
				break;
			}
		}while(!(GPIOB->LCKR&0x00010000));//ȡΪ0 

	}while(GPIOB->LCKR&0x00010000);//ȡΪ1
		
}

void delay_ms(unsigned int tmp)
{
	unsigned int x,y;

	for(x=tmp;x>0;x--)
	{
		for(y=8000;y>0;y--)
		{
			;;
		}
	}
}
